/**
 *
 *Custom Google Analytics
 *
 */

if (BrowserDetect.OS == 'Windows' || BrowserDetect.OS == 'Linux' || BrowserDetect.OS == 'Mac') {
	
var GA_TRACKING_ID='UA-295754-39';

if (!localStorage['gaId']) {
	var date=new Date();
    localStorage['gaId'] = $.md5(date.toString());
}

var GA_CLIENT_ID=localStorage['gaId'];

//var _gaq = _gaq || [];
//	_gaq.push(['_setAccount', GA_TRACKING_ID]);
//	_gaq.push(['_trackPageview']);
	
	var message =
		  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
		  "&ds=add-on&t=pageview&ec=AAA&dp="+document.body.className;
	
	//console.log("google pageview", message);
	
	$.ajax({
      url: 'https://www.google-analytics.com/collect',
      type: 'POST',
      data: message, 
      cache: false
  });



function init() {
	switch (document.body.className) {
	case 'popup_page':
		trackPopup();
		break;
	case 'edit_page':
		trackEdit();
		break;
	case 'options_page':
		trackOptions();
		break;
	}

	function trackPopup() {
		var ul = document.getElementsByTagName('ul')[0];
		ul.addEventListener('click', clickHandler, false);
		
		function clickHandler(e) {
			
			var message =
				  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
				  "&ds=add-on&t=event&ec=Captures&el=capture&ev=300&ea="+e.target.id;
			
			$.ajax({
		      url: 'https://www.google-analytics.com/collect',
		      type: 'POST',
		      data: message, 
		      cache: false
			});
		}
	}
	
	function trackEdit() {
		//track tool-panel link
		$('#tool-panel>a').click(function(e) {
			
			var message =
				  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
				  "&ds=add-on&t=event&ec=Annotations&el=click&ev=300&ea="+e.target.id;
			
			$.ajax({
		      url: 'https://www.google-analytics.com/collect',
		      type: 'POST',
		      data: message, 
		      cache: false
			});
		});
	
		//track annotation panel
		$('#tool-panel>div, #feedback').click(function(e) {
			var target = getTarget(e.target);
			if (target.nodeName == 'DIV') 
				return;
			
			var message =
				  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
				  "&ds=add-on&t=event&ec=Annotations&el=click&ev=300&ea="+target.id;
			
			$.ajax({
		      url: 'https://www.google-analytics.com/collect',
		      type: 'POST',
		      data: message, 
		      cache: false
			});
			
			function getTarget(t) {
				var node = t.nodeName;
				if ((node != 'A' && node != 'DIV') || t.parentNode.nodeName=='LI' || t.parentNode=='LI') { 
					t = t.parentNode;
					getTarget(t);
				}
				return t;
			}
		});
		
		$('#save').click(function(e) {
			//track re-edit
			$('#re-edit').click(function(e) {				
				var message =
					  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
					  "&ds=add-on&t=event&ec=SavePageActions&el=click&ev=300&ea=re_edit";
				
				$.ajax({
			      url: 'https://www.google-analytics.com/collect',
			      type: 'POST',
			      data: message, 
			      cache: false
				});
				
				$('#save-tip').unbind('click', saveTipTrackClickHandler);
			});
			
			//track all links in #save-tip
			$('#save-tip').click(saveTipTrackClickHandler);
		});
		
		function saveTipTrackClickHandler(e) {
			if (e.target.tagName == 'A') {

				var message =
					  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
					  "&ds=add-on&t=event&ec=SavePageActions&el=click&ev=300&ea="+$(e.target).attr('id');
				
				$.ajax({
			      url: 'https://www.google-analytics.com/collect',
			      type: 'POST',
			      data: message, 
			      cache: false
				});
			}
			
			//share link 
			if (e.target.tagName == 'INPUT') {
				
				var message =
					  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
					  "&ds=add-on&t=event&ec=SavePageActions&el=click&ev=300&ea=share_link";
				
				$.ajax({
			      url: 'https://www.google-analytics.com/collect',
			      type: 'POST',
			      data: message, 
			      cache: false
				});
			}
			
			function getGALabel(imageFileSize) {
				var label = '0.0Mb';
				
				if (imageFileSize<=0.2) 
					label = '0.2Mb';
				else if (imageFileSize<=0.4) 
					label = '0.4Mb';
				else if (imageFileSize<=0.6) 
					label = '0.6Mb';
				else if (imageFileSize<=1.0) 
					label = '1.0Mb';
				else if (imageFileSize<=1.5) 
					label = '1.5Mb';
				else if (imageFileSize<=2.0) 
					label = '2.0Mb';
				else if (imageFileSize<=3.0) 
					label = '3.0Mb';
				else if (imageFileSize<=4.0) 
					label = '4.0Mb';
				else if (imageFileSize<=5.0) 
					label = '5.0Mb';
				else
					label = '>5.0Mb';
				
				return label;
			}
		}
		
		//track promote
		$('#feedback').click(function(e) {
			if (e.target.tagName == 'A') {
				/* alert($(e.target).parent().attr('id')); */				
				var message =
					  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
					  "&ds=add-on&t=event&ec=SavePageActions&el=click&ev=300&ea="+$(e.target).parent().attr('id');
				
				$.ajax({
			      url: 'https://www.google-analytics.com/collect',
			      type: 'POST',
			      data: message, 
			      cache: false
				});

			}
		});
	}
	
	function trackOptions() {
		$('#action_panel').click(function(e) {
			if (e.target.tagName == 'INPUT') {
				var message =
					  "v=1&tid=" + GA_TRACKING_ID + "&cid="+GA_CLIENT_ID+"&aip=1" +
					  "&ds=add-on&t=event&ec=SavePageActions&el=click&ev=300&ea=";
				
				switch (e.target.value) {
				case 'Reset':
					message+="Reset";
					break;
				case 'Save':
					message+="Save";
					break;
				case 'Close':
					message+="Close";
					break;
				}
				
				$.ajax({
				      url: 'https://www.google-analytics.com/collect',
				      type: 'POST',
				      data: message, 
				      cache: false
					});
			}
		});
	}
}

window.onload = init;
}