var customEvent = document.createEvent('Event');
customEvent.initEvent('myCustomEvent', true, true);

function fireCustomEvent(data) {
  hiddenDiv = document.getElementById('messageChannel');
  hiddenDiv.innerText = data;
  hiddenDiv.dispatchEvent(customEvent);
}

function downloadImage(dataInfo){
	var base64 = dataInfo.imageData, type = dataInfo.imageType, fname= dataInfo.imageName, ct=dataInfo.contentType;
	
    function b64toBlob(b64Data, contentType, sliceSize) {
        contentType = contentType || 'image/png';
        sliceSize = sliceSize || 1024;
        
//        byteString = unescape(dataURI.split(',')[1]);

        //console.log('retrive_download_image: ', b64Data);
        var byteCharacters = atob(b64Data);
        //console.log('retrive_download_image atob: ', byteCharacters);
        
        var rawLength=byteCharacters.length;
        
        var byteArrays = new Uint8Array(rawLength);

        for (var i = 0; i < rawLength; ++i) {
        	byteArrays[i] = byteCharacters.charCodeAt(i);
        }

        var bb = new Blob([byteArrays], {type : contentType});
        return bb;
    }

    var blob = b64toBlob(base64, ct);

    var winUri=(window.webkitURL || window.URL || window.mozURL);
    var blobUrl = winUri.createObjectURL(blob);
    
    
    //console.log('retrive_download_image: ', blobUrl);
    var a = document.createElement('a');
    a.href = blobUrl;
    a.download = fname;
    document.body.appendChild(a);
    a.click();
    
    setTimeout(function(){
    	winUri.revokeObjectURL(blob);
    }, 500);
}



chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
//	//console.log('save content: ', request);
	
	if (request.action==='return_image_data') {
		fireCustomEvent(JSON.stringify(request));
	}
	return true;
});

chrome.runtime.sendMessage({action:"retrive_download_image"}, function(req){
	//console.log('retrive_download_image: ', req);
	downloadImage(req);
});
