var BG = chrome.extension.getBackgroundPage();

document.getElementById('image_file').addEventListener('change', handleFileSelect, false);

// Setup the dnd listeners.
var dropZone = document.getElementById('dropZone');
dropZone.addEventListener('dragover', handleDragHover, false);
dropZone.addEventListener('dragleave', handleDragHover, false);
dropZone.addEventListener('drop', handleFileDrop, false);


document.body.addEventListener('dragover',function(e){
    //console.log("ddf");
    e.stopPropagation();
    e.preventDefault();
    e.dataTransfer.dropEffect = 'none';

},false);

function handleFileDrop(e) {
    e.stopPropagation();
    e.preventDefault();

    var file = e.dataTransfer.files[0]; // FileList object.

    readFile(file);
}

function handleFileSelect(evt) {
    evt.stopPropagation();
    evt.preventDefault();

    var file = evt.target.files[0]; // FileList object.

    readFile(file);
}

function readFile(file) {
    var name = file.name.match(/(.*)\.(png|jpg|jpeg|PNG|JPG|JPEG)$/)[1];
    var reader = new FileReader();

    reader.onload = function(e) {
        var dataURL = e.target.result;
        //console.log('readFile: '+dataURL);
        BG.getSelectedTab(function(){
            BG.type = 'visible';
            BG.menuType = 'upload';

            BG.tabtitle = name;
            BG.dataURL.push(dataURL);
            var url = chrome.extension.getURL('') + "edit.html";
            chrome.tabs.update({url:url});
        });


    };

    reader.readAsDataURL(file);
}

function handleDragHover(evt) {
    evt.stopPropagation();
    evt.preventDefault();
    evt.dataTransfer.dropEffect = 'move'; // Explicitly show this is a copy.
    dropZone.className = (evt.type == "dragover") ? "hover" : "";
}